;Periodendauermesser fr DDR-Uhrenschaltkreis U114/U124 zur Frequenzbestimmung von Quarzen/Oszillatoren/Schwingkreisen
;
;orginal Einsatz eines 4,19 MHz-Quarzes, Arbeitsbereich etwa 100 kHz bis 10 MHz (Funkbereich!)
;23-stufiger, binrer Frequenzteiler, symmetrische Motorausgnge, versetzte 0,5 Hz-Ausgangssignale, Betriebsspannung 1,2 bis 1,7 V			
;Literatur: electronica 215, Einsatzbeispiele fr CMOS-Schaltkreise, Klaus Schlenzig
;bei anderen ICs (z.B. 2x CD4060): Messbereich prfen (hier ca. 0,1 bis 255,99 sek), evtl. einfachere Ergnzungsschaltung
;Ergnzungsschaltung: UCC-Reduzierung auf 1,5 V, Pegelanpassung von (einem) Motorausgang auf PB3 mit Transistor, evtl. LED-Kontrolle
;Messung einer halben Periodendauer (HINWEIS: symmetrischer Ausgangstakt erforderlich, andernfalls Programm anpassen!)
;mgliche Programm-Erweiterung: berlaufanzeige 256 sek auf PB4
;
;Auswertung mit dem Taschenrechner (erste Teilmessung verwerfen): Teilerfaktor 4.194.304 aus Speicher geteilt durch 
;erste Ausgabezahl + Komma-Eingabe + zweite Ausgabezahl (Fhrungsnull bei 0-9 ergnzen), Ergebnis = Frequenz in Hz

    .include "tn13def.inc"

	.def   sicher	= r04
	.def   temp		= r16
	.def   time		= r17	;Teiler-Register auf 0,01 sek
	.def   hsek		= r18	;Hundertstelsekunden (max. Zhlumfang 100)
	.def   sek		= r19	;Sekunden
	.def   A		= r20
	.def   Delay	= r21
	.def   Count	= r22

 ;Port B
	.equ   TXD	= 1
	.equ   RXD	= 2

	rjmp Anfang
	.org 0x0003 
	rjmp TIM0_OVF   	;Timer0 Overflow 

Anfang:
	cbi ddrb,3    		;Datenrichtung
	sbi portb,3			;PullUp-Vorwiderstand
	ldi temp,2    		;Start mit Vorteiler / 8
	out TCCR0B,temp
	ldi temp,2
	out TIMSK0,temp		;Timer Interrupt freigeben
Neu:
	clr time
	clr hsek
	clr sek
Aus:
	sbis pinb,3
	rjmp Aus
	sei					;Globaler Interrupt frei   
Ein:
	sbic pinb,3
	rjmp Ein
	cli
	ldi A,0
	rcall WrCOM			;fhrende Trenn-Null
	mov A,sek
	rcall WrCOM			;Sekunden
	mov A,hsek
	rcall WrCOM			;Hundertstelsekunden
	ldi A,0
	rcall WrCOM			;abschlieende Trenn-Null
	rjmp Neu

TIM0_OVF:				;Timer Interrupt
	in sicher,SREG 
	ldi temp,106 
	out TCNT0,temp  	;Zhlumfang 150 bis Overflow = 0,001 sek
	inc time			;Teiler-Register
	cpi time,10		;teilt auf 0,01 sek
	brlo TIM0_ende
	clr time
	inc hsek
	cpi hsek,100		;max. Zhlumfang 0 bis 99
	brlo TIM0_ende
	inc sek
	clr hsek
TIM0_ende:
	out   SREG,sicher
	reti


WrCOM:	sbi   portb,TXD	;Senden (aus Lernpaket-Datei einkopieren)
		ldi   Delay,38 
D4:		dec   Delay
		brne  D4
		ldi   Count,8
L2:		sbrc  A,0
		rjmp  OFF
		nop
		rjmp  ON
ON :	sbi   portb,TXD
		rjmp  BitD
OFF:	cbi   portb,TXD
		rjmp  BitD
BitD:	ldi   Delay,38  
D5:		dec   Delay
		brne  D5
		lsr   A
		dec   Count
		brne  L2
		cbi   PORTB,TXD
		ldi   Delay,38  
D6:		dec   Delay
		brne  D6
		ret


